﻿using System;
using System.Windows.Forms;
using BR.AN.PviServices;

namespace sample_01
{   
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        Service service;
        Cpu cpu;

        string ip_adress;
        string cpu_name;

        private void Form1_Load(object sender, EventArgs e)
        {
            //默认选择ARSim本地仿真
            radioButton1.Checked = true;
        }

        private void btConnectPLC_Click(object sender, EventArgs e)
        {
            if (service == null)
            {
                service = new Service("service");
                service.Connected += new PviEventHandler(service_Connected);
            }
            service.Connect();
        }
        /// <summary> 
        /// Connect CPU object if service object connection successful 
        ///</summary> 
        private void service_Connected(object sender, PviEventArgs e)
        {
                // Create CPU object and add the event handler 
            if (cpu == null)
            {
                if (radioButton1.Checked)
                {
                    cpu_name = "ARsim";
                    textBox2.Text = "127.0.0.1";
                    ip_adress = textBox2.Text;
                }

                if (radioButton2.Checked)
                {
                    ip_adress = textBox2.Text;
                    cpu_name = "Remote_PLC";
                }
                this.cpu = new Cpu(service, cpu_name);
                this.service.Cpus[cpu_name].Connected += new PviEventHandler(cpu_Connected);
                // Set the connection properties for a serial connection 
                this.service.Cpus[cpu_name].Connection.DeviceType = DeviceType.ANSLTcp;
                this.service.Cpus[cpu_name].Connection.ANSLTcp.DestinationIpAddress = ip_adress;
                this.service.Cpus[cpu_name].Connection.ANSLTcp.ResponseTimeout = 2000;
                
            }
            this.service.Cpus[cpu_name].Connect();
        }
        /// <summary> 
        /// Output text when connection to CPU successful and   
        /// enable Variable Connect button 
        /// </summary> 
        private void cpu_Connected(object sender, PviEventArgs e)
        {
            this.listBox2.Items.Add(this.ip_adress + ":  " + "is connected\r\n");
        }

        private void btConnectVariable_Click(object sender, EventArgs e)
        {
            if (cpu != null)
            {
                this.cpu.Variables.Uploaded += new PviEventHandler(GlobalVariablesUploaded);
                this.cpu.Variables.Upload();
            }
            
        }

        private void GlobalVariablesUploaded(object sender, PviEventArgs e)
        {
            this.listBox1.Items.Clear();
            foreach (Variable variable in this.cpu.Variables.Values)
            {
                listBox1.Items.Add(variable.Name);
            }
            this.listBox2.Items.Add( "Global variablies uploaded\r\n");
        }   

        private void btVarWrite_Click(object sender, EventArgs e)
        {
            if ((textBox1.Text != "")&&(listBox1.SelectedItem != null))
            {
                this.cpu.Variables[listBox1.SelectedItem.ToString()].Value = textBox1.Text;           
                this.cpu.Variables[listBox1.SelectedItem.ToString()].Active = true;
                this.cpu.Variables[listBox1.SelectedItem.ToString()].Connect();
                this.cpu.Variables[listBox1.SelectedItem.ToString()].ValueWritten += new PviEventHandler(Var_ValueWritten);

                //以下案例说明对任意的全局变量多层结构体中任意变量链接并写入方式
                //this.cpu.Variables["axConveyor"].Connect();
                //this.cpu.Variables["axConveyor"].Active = true;
                //this.cpu.Variables["axConveyor"].Value["simulation.parameter.mass1.inertia"] = 25; //结构体成员赋值
            }
        }

        private void Var_ValueWritten(object sender, PviEventArgs e)
        {
            this.listBox2.Text += this.cpu.Variables[listBox1.SelectedItem.ToString()].Name + ":is written";
        }

        private void btUploadTaskInfo_Click(object sender, EventArgs e)
        {
            if (this.cpu != null)
            {
                this.cpu.Tasks.Uploaded += new PviEventHandler(TaskInfoUploaded);
                this.cpu.Tasks.Upload();
            }
        }

        private void TaskInfoUploaded(object sender, PviEventArgs e)
        {
            this.listBox2.Items.Add("Task information uploaded\r\n");

            // Inserting the task objects into the ListBox 
            this.list_tasks.Items.Clear();
            foreach (Task task in cpu.Tasks.Values)
            {
                this.list_tasks.Items.Add(task.Name);
            }
            this.cpu.Tasks.Uploaded -= new PviEventHandler(TaskInfoUploaded);
        }

        private void btConnectTask_Click(object sender, EventArgs e)
        {
            // Add handler and establish connection 
            if (this.list_tasks.SelectedItem != null)
            {
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Connected += new PviEventHandler(SelectedTaskConnected);
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Connect();
            }
        }

        private void SelectedTaskConnected(object sender, PviEventArgs e)
        {
            this.listBox2.Items.Add( "Task:" + this.list_tasks.SelectedItem.ToString() + "  " + "is connected\r\n");
        }

        private void btUploadLocalVariables_Click(object sender, EventArgs e)
        {
            if (this.list_tasks.SelectedItem != null)
            {
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables.Uploaded += new PviEventHandler(SelectedTaskVariablesUploaded);
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables.Upload();
            } 
        }
        /// <summary> 
        /// Local variable information of the selected task object 
        /// read successfully 
        /// </summary> 
        private void SelectedTaskVariablesUploaded(object sender, PviEventArgs e)
        {
            this.list_variables.Items.Clear();
            foreach (Variable variable in this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables.Values)
            {
                this.list_variables.Items.Add(variable.Name);
            }
            this.listBox2.Items.Add("Local variables uploaded\r\n");
        }


        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            ip_adress = textBox2.Text;
        }

        private void globalVarRead_Click(object sender, EventArgs e)
        {
            if (this.listBox1.SelectedItem != null)
            {
                this.cpu.Variables[this.listBox1.SelectedItem.ToString()].Active = true;
                this.cpu.Variables[this.listBox1.SelectedItem.ToString()].RefreshTime = 1;
                this.cpu.Variables[this.listBox1.SelectedItem.ToString()].Polling = false;
                this.cpu.Variables[this.listBox1.SelectedItem.ToString()].Connect();

                this.cpu.Variables[this.listBox1.SelectedItem.ToString()].ValueChanged += new VariableEventHandler(globalVarReaded);
                this.listBox2.Items.Add(this.listBox1.SelectedItem.ToString() + "  :" + "is reading\r\n");
            }
        }

        private void globalVarReaded(object sender, VariableEventArgs e)
        {
            if ((this.listBox1.SelectedItem != null) &&(this.cpu.Variables[this.listBox1.SelectedItem.ToString()].IsConnected))
            {

                this.textBox6.Text = this.cpu.Variables[this.listBox1.SelectedItem.ToString()].Value.ToString();
            }
        }

        private void localVarRead_Click(object sender, EventArgs e)
        {
            if ((this.list_tasks.SelectedItem != null) && (this.list_variables.SelectedItem != null))
            {
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Active = true;
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Connect();
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].ValueChanged += new VariableEventHandler(localVarReaded);
                this.listBox2.Items.Add(this.list_variables.SelectedItem.ToString() + "  :" + "is reading\r\n");         
            } 
        }
        private void localVarReaded(object sender, VariableEventArgs e)
        {
            if ((this.list_variables.SelectedItem != null) && (this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].IsConnected))
            this.textBox4.Text = this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Value.ToString();
        }

        private void btLocalWrite_Click(object sender, EventArgs e)
        {
            if ((textBox5.Text != "") && (list_variables.SelectedItem != null))
            {
                //注意根据PLC变量类型的不同，请调用不同的方法Convert.ToDouble/Convert.ToByte/Convert.ToInt16/Convert.ToInt32等
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Value = Convert.ToDouble(textBox5.Text.ToString());

                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Active = true;
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Connect();
                this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].ValueWritten += new PviEventHandler(localVar_ValueWritten);
            }
        }

        private void localVar_ValueWritten(object sender, PviEventArgs e)
        {
            this.listBox2.Text += this.cpu.Tasks[this.list_tasks.SelectedItem.ToString()].Variables[this.list_variables.SelectedItem.ToString()].Name + "  :is written\r\n";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if  (cpu != null)
            {
                this.cpu.Restart(BR.AN.PviServices.BootMode.WarmRestart);
                this.listBox2.Items.Add("CPU restarting ........\r\n");
                this.cpu.Restarted += new PviEventHandler(CPU_Restarted); 
            }
        }

        private void CPU_Restarted(object sender, PviEventArgs e)
        {
            this.listBox2.Items.Add("CPU restarted successfully\r\n");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.listBox2.Items.Clear();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}

